let atp_add_deps = setify (List.map (hash_th o find_thm) ["TRUTH"; "EQ_EXT"; "BOOL_CASES_AX"; "NOT_CLAUSES_WEAK_conjunct1"]);;

let write_to_prove_pred md chunks file =
  let pred_hash = Hashtbl.create 2000 in
  let inc = Pervasives.open_in file in
  (try while true do
    match string_list_of_string (input_line inc) ':' with
    | [t; e] ->
        Hashtbl.add pred_hash t (string_list_of_string e ' ');
    | [t] ->
        Hashtbl.add pred_hash t [];
    | _ -> failwith "load_deps2"
  done with End_of_file -> close_in inc);
  let pred_deps max s =
    let deps = union atp_add_deps (setify (Hashtbl.find pred_hash s)) in
    fst (chop_listnok [] max deps) in
  let all_thms = List.fold_left name2pairs [] !theorems in
  let foftscsused = fof_gl_mk_hash (List.map (concl o snd) all_thms) in
  let tfftscsused = tff_gl_mk_hash (List.map (concl o snd) all_thms) in
  let probs = cut_list md 0 (List.rev (List.map fst all_thms)) in
  let write_n_probs max =
    fileno := 0;
    let prf = Printf.sprintf "%s_%i" file max in
    let itf s =
      try
        let deps = pred_deps max s in
        fileno := !fileno + 1;
        let filen = Printf.sprintf "%sf%05i.p" prf !fileno in
        let ts = rev (List.fold_left (fun l n -> (*try*) find_thm n :: l
  (*with Not_found -> (print_endline ("!!!!!!!"^n); (TRUTH :: l))*)) [] deps) in
        let gl = (concl (normalize_th (find_thm s))) in
        let (_, [g], _) = mk_goalstate ([],gl) in
        begin match (PREP_HH_TAC deps false (map normalize_th ts) THEN PREP_TFF_TAC THEN FOL_IT_TAC) g with
          (_, [g2], _) ->
            let oc = open_out filen in
            let deps = map fst (fst g2) in
            fof_gl_hash oc deps s (map (concl o snd) (fst g2)) (snd g2) foftscsused;
            close_out oc;
        | _ -> failwith ("PREP_HH_TAC created more goals: " ^ s)
        end
      with
        Failure x -> print_endline x
      | Not_found -> print_endline s
    in List.iter itf probs
  in
  List.iter (fun n -> write_n_probs n) chunks
;;

let write_all = write_to_prove_pred 1 [1000];;

let write_to_prove_all () =
  let deps, ts = List.split (List.fold_left name2pairs [] !theorems) in
  let foftscsused = fof_gl_mk_hash (List.map concl ts) in
  let tfftscsused = tff_gl_mk_hash (List.map concl ts) in
  let gl = `F` in
  let (_, [g], _) = mk_goalstate ([],gl) in
  begin match (PREP_HH_TAC deps false ts THEN PREP_TFF_TAC THEN FOL_IT_TAC) g with
    (_, [g2], _) ->
      let deps = map fst (fst g2) in
      let oc = open_out "all_fof.p" in
      fof_gl_hash oc deps "F" (map (concl o snd) (fst g2)) (snd g2) foftscsused;
      close_out oc;
      let oc = open_out "all_tff1.p" in
      tff_gl_hash oc deps "F" (map (concl o snd) (fst g2)) (snd g2) tfftscsused;
      close_out oc
  | _ -> () (* Happens for 'TRUTH' *)
  end
;;

let write_to_prove_all file max =
  let inc = Pervasives.open_in file in
  let all_thms = List.fold_left name2pairs [] !theorems in
  let foftscsused = fof_gl_mk_hash (List.map (concl o snd) all_thms) in
  let tfftscsused = tff_gl_mk_hash (List.map (concl o snd) all_thms) in
  fileno := 0;
  let prf = Printf.sprintf "%s_%i" file max in
  let dowrite s deps =
    let deps = let deps = union atp_add_deps deps in setify (fst (chop_listnok [] max deps)) in
    let ts = rev (List.fold_left (fun l n -> (*try*) GEN_ALL (DISCH_ALL (find_thm (find_hash n))) :: l
          (*with Not_found -> (print_endline ("!!!!!!!"^n); (TRUTH :: l))*)) [] deps) in
    let gl = (concl (GEN_ALL (DISCH_ALL (find_thm (find_hash s))))) in
    let (_, [g], _) = mk_goalstate ([],gl) in
    begin match (PREP_HH_TAC deps false (map normalize_th ts) THEN PREP_TFF_TAC THEN FOL_IT_TAC) g with
      (_, [g2], _) ->
        incr fileno;
        let filef = Printf.sprintf "%sf%05i.p" prf !fileno in
(*      let filef = Printf.sprintf "f%s.p" (md5 (s, deps)) in*)
        let filep = Printf.sprintf "%sp%05i.p" prf !fileno in
        let deps = map fst (fst g2) in
        let oc = open_out filef in
        (try fof_gl_hash oc deps s (map (concl o snd) (fst g2)) (snd g2) foftscsused with _ -> ());
        close_out oc;
        let oc = open_out filep in
        tff_gl_hash oc deps s (map (concl o snd) (fst g2)) (snd g2) tfftscsused;
        close_out oc;
     | _ -> () (* Happens for 'TRUTH' *)
    end;
    let fileh = Printf.sprintf "%sh%05i.p" prf !fileno in
    try write_thf_proof fileh (ts, deps) s gl with _ -> ();
  in
  try while true do
    match string_list_of_string (input_line inc) ':' with
    | [t; e] -> (try dowrite t (string_list_of_string e ' ') with Not_found -> ())
    | [t] -> (try dowrite t [] with Not_found -> ())
    | _ -> failwith "load_deps3"
  done with End_of_file -> close_in inc;
;;
