HOL Light Tactics
=================

This package contains versions of leanCoP and nanoCoP for
proof search inside HOL Light.


Requirements
------------

This package was tested with:

- OCaml 4.02.3
- Camlp5 6.14
- DMTCP 2.5.1


Evaluation
----------

To run the evaluation and export of the MESON goals:

    make {hol-light,flyspeck}/HH/meson -j40
    make {hol-light,flyspeck}-meson.tar.bz2

Note that the first command runs 40 processes in parallel
inside the same HOL Light session.
This is done with the help of the GNU make jobserver.

To create HOL Light and Flyspeck checkpoints, run:

    make {hol-light,flyspeck}/ckpt_hl_deps

This will actually run two passes.
It is important that at this point, `make` is **not** run in parallel,
because `fusion.ml` in the HOL Light directory is changed in function
of the pass.

Once the checkpoints are created, the toplevel theorems can be exported
respectively the toplevel evaluation inside HOL Light can be started.
For this, run:

    make {hol-light,flyspeck}/HH/toplevel-eval/5s
    make {hol-light,flyspeck}-top.tar.bz2
