module Cop = struct

module Subst = Substoff (Substarray)

type search_opts =
{ cut1 : bool
; cut2 : bool
; cut3 : bool
; comp : int
; improved_lemmas : bool
; improved_regularity : bool
; add_eq_symmetry : bool
}

let search_opts =
{ cut1 = true
; cut2 = true
; cut3 = true
; comp = 7
; improved_lemmas = true
; improved_regularity = true
; add_eq_symmetry = true
}

let rec deepen f i = match f i with Some x -> x | None -> deepen f (i+1)
let rec deepen_to n f i =
  if i > n then None
  else match f i with None -> deepen_to n f (i+1) | s -> s

let strategy opt f =
  if opt.cut1 || opt.cut2 || opt.cut3 then
    match deepen_to opt.comp (f opt) 0 with
      None -> deepen (f {opt with cut1 = false; cut2 = false; cut3 = false}) 0
    | Some prf -> prf
  else
    deepen (f opt) 0

end
