module Database = struct

type contrapositive = (fol_term list * fol_atom list * int * (int * thm))

let clause_max_var cl = 1 + List.fold_left Fol_term.lit_max_var (-1) cl

let mapentry ((cl_rest, (p, args)), th) =
  (args, cl_rest, clause_max_var ((p, args) :: cl_rest), th)

(* for every predicate, store list of possible contrapositives *)
let db : (int, contrapositive list) Hashtbl.t = Hashtbl.create 10017

let axioms2db ths =
  Hashtbl.clear db;
  Mapping.fol_of_hol_clauses ths |>
  List.iter (fun (p, l) -> Hashtbl.add db (-p) (map mapentry l))

let db_entries lit =
  try Hashtbl.find db (fst lit) with Not_found -> []

end
