(* Manual proof of IJCAR'16 nonclausal example *)

let negated = `p(a:t) /\ ((q(f(f(c:t))) /\ (!A. (~q(f(A)) \/ q(A:t))) /\ ~q(c)) \/ !A. (~p(A) \/ p(g(A)))) /\ !A. ~p(g(g(A)))`;;

let solve_rule asm =
  let [l0; c1; c8] = CONJUNCTS asm in
  let l81 = SPEC `a:t` c8 in
  let [m2tm; m6tm] = disjuncts (concl c1) in
    let m6 = ASSUME m6tm in
    let c71 = SPEC `g(a:t):t` m6 in
    let [l711tm; l712tm] = disjuncts (concl c71) in
      let l712 = ASSUME l712tm in
      let l712ref = MP (NOT_ELIM l81) l712 in

      let l711 = ASSUME l711tm in
      let c72 = SPEC `a:t` m6 in
      let [l721tm; l722tm] = disjuncts (concl c72) in
        let l722 = ASSUME l722tm in
        let l722ref = MP (NOT_ELIM l711) l722 in

        let l721 = ASSUME l721tm in
        let l721ref = MP (NOT_ELIM l721) l0 in

      let l711ref = DISJ_CASES c72 l721ref l722ref in

    let m6ref = DISJ_CASES c71 l711ref l712ref in

    let m2 = ASSUME m2tm in
    let [l3; c4; l5] = CONJUNCTS m2 in
    let c41 = SPEC `f(c:t):t` c4 in
    let [l411tm; l412tm] = disjuncts (concl c41) in
      let l411 = ASSUME l411tm in
      let l411ref = MP (NOT_ELIM l411) l3 in

      let l412 = ASSUME l412tm in
      let c42 = SPEC `c:t` c4 in
      let [l421tm; l422tm] = disjuncts (concl c42) in

        let l421 = ASSUME l421tm in
        let l421ref = MP (NOT_ELIM l421) l412 in

        let l422 = ASSUME l422tm in
        let l422ref = MP (NOT_ELIM l5) l422 in

      let l412ref = DISJ_CASES c42 l421ref l422ref in

    let l3ref = DISJ_CASES c41 l411ref l412ref in

  let l81ref = DISJ_CASES c1 l3ref m6ref in
  l81ref;;

g (mk_imp (negated, `F`));;
e DISCH_TAC;;
e (FIRST_ASSUM (fun asm -> ACCEPT_TAC (solve_rule asm)));;
