module Ncdatabase =
struct

open Ncmatrix
open Extclause

(* position of the literal in matrix, literal arguments, groundness, variable offset *)
type 'v contrapositive = 'v clause_ext * fol_term list * bool * int

let db : (int, int contrapositive list) Hashtbl.t = Hashtbl.create 10000

let insert_db db ((p, a), clext) =
  let matC = snd (matBC_of_clause_ext clext) in
  let off = 1 + Ncmatrix.matrix_max_var (-1) matC in
  let ground = litext_of_clause_ext clext |> snd |> Ncmatrix.clause_ground in
  (*Format.printf "Insert lit: %s with offset %d and claC: %s\n%!" (Print.string_of_lit (p,a)) off (Ncprint.string_of_matrix matC);*)
  let v = clext, a, ground, off in
  try Hashtbl.find db p |> (fun l -> v :: l) |> Hashtbl.replace db p
  with Not_found -> Hashtbl.add db p ([v])

let matrix2db m =
  let predb = assert_matrix m in
  Hashtbl.clear db;
  List.iter (insert_db db) (List.rev predb)

let db_entries lit = try Hashtbl.find db (fst lit) with Not_found -> []

end
