module Recon = struct

open Proof
open Utils

let hol_negate tm = try dest_neg tm with Failure _ -> mk_neg tm;;

let rec hashek_of_proof sub lem lit =
  let liti = Mapping.hol_of_literal (Substarray.inst_lit sub lit) in
  function
    Lemma -> find (fun x -> concl x = liti) lem
  | Reduction -> ASSUME liti
  | Extension (contra, prfs) ->
      let _, ths = List.fold_map (fun lem (lit, prf) ->
        let p = hashek_of_proof sub lem lit prf in p :: lem, p) lem prfs in
      let cth = Meson.make_hol_contrapos contra in
      let hth = if ths = [] then cth else MATCH_MP cth (end_itlist CONJ ths) in
      let ith = PART_MATCH I hth liti in
      Meson.finish_RULE (DISCH (hol_negate (concl ith)) ith)

end
