#!/usr/bin/env python

# Construct a Markdown table generated by output of a script.

import sys
import subprocess

def print_table(header, align, body):
    print '|'.join(header)

    aligns = {
        "n": "-",
        "l": ":-",
        "r": "-:"
    }
    print '|'.join([aligns[a] for a in align])

    for row in body:
        print '|'.join(row)

# subprocess.check_output() only exists in Python >=2.7
def read_output(cmd):
    process = subprocess.Popen(cmd, stdout=subprocess.PIPE)
    out, err = process.communicate()
    return out

if len(sys.argv) <= 4:
    print "Usage: " + sys.argv[0] + " <cols> <align> <rows> <cmd>"
    print "Example: " + sys.argv[0] + ' \'["P", "D1", "D2"]\' nlr \'["P1", "P2"]\' echo'
    sys.exit(1)

cols = eval(sys.argv[1])
align = sys.argv[2]
rows = eval(sys.argv[3])
cmd = sys.argv[4]

get = lambda x,y: read_output([cmd, x, y]).strip()
body = [[row] + [get(col, row) for col in cols[1:]] for row in rows]

print_table(cols, align, body)
