include Makefile

DATASETS = \
  hol-light/HH/toplevel-eval/10s \
  hol-light/HH/meson-eval/10s \
   flyspeck/HH/toplevel-eval/10s \
   flyspeck/HH/meson-eval/10s

# A literal space.
space :=
space +=

comma := ,

# Joins elements of the list in arg 2 with the given separator.
#   1. Element separator.
#   2. The list.
join-with = $(subst $(space),$1,$(strip $2))

quote = $(patsubst %,"%",$1)

# Make a list of strings readable by Python
quote-list = $(subst $(space),$(comma),$(call quote,$1))

right-align = $(subst $(space),,$(patsubst %,r,$1))

table1.raw.md: eval/tablegen.py
	$< '["Prover", $(call quote-list,$(DATASETS))]' \
	   n$(call right-align,$(DATASETS)) \
	   '[$(call quote-list,$(TACTICS))]' \
	   eval/getsolved.sh > $@

REPLACEMENT = \
  hol-light/|HL \
  flyspeck/|FS \
  HH/meson-eval/10s|-meson \
  HH/toplevel-eval/10s|-top \
  nanocop|nanoCoP \
  leancop|leanCoP \
  meson-sl|MESON-sl \
  metis|Metis \
  -sl0| \
  -sl8|$$+$$sl8

sed = sed $(patsubst %,-e 's|%|g',$1)

table1.lut.md: table1.raw.md tables.mk
	$(call sed,$(REPLACEMENT)) $< > $@

table1.md: table1.lut.md
	pandoc $< -t markdown-simple_tables -o $@
